#include  <stdio.h>
#include  <stdlib.h>
#include  <sys/types.h>
#include  <dirent.h>

//  Compile me with:  cc -std=c11 -Wall -Werror -o myls1 myls1.c

void scan_directory(char *dirname)        
{
    DIR             *dirp;
    struct dirent   *dp;

//  ENSURE THAT WE CAN OPEN (read-only) THE REQUIRED DIRECTORY
    dirp       = opendir(dirname);
    if(dirp == NULL) {
        perror( dirname );
        exit(EXIT_FAILURE);
    }

//  READ FROM THE REQUIRED DIRECTORY, UNTIL WE REACH ITS END
    while((dp = readdir(dirp)) != NULL) {  
        printf( "%s\n", dp->d_name );
    }

//  CLOSE THE DIRECTORY
    closedir(dirp);
}

int main(int argc, char *argv[])
{
//  LIST THE CURRENT DIRECTORY
    if(argc == 1) {
        scan_directory(".");
    }

//  LIST EVERY DIRECTORY REQUESTED ON THE COMMAND-LINE
    else {
        for(int a=1 ; a<argc ; ++a) {
            scan_directory(argv[a]);
        }
    }
    return 0;
}
